<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Gestion des droits de création des profils</h1>
    </mt-page-title>
    <section class="grid-droit-creation-profil" :style="`--grid-size : ${profilsCreateur.length} `">
      <div>
        <span>↓ Ces profils peuvent créér →</span>
      </div>
      <div v-for="(profil, index) in profilsCreateur" :key="`p1-${index}`">
        {{ profil.code }}
      </div>
      <template v-for="(profil, index) in profilsCreateur">
        <div :key="`p2-${index}`">{{ profil.code }}</div>
        <div v-for="(droit, index2) in profil.droitsCreationsProfilDto" :key="`p3-${index}-${index2}`">
          <b-checkbox v-model="droit.exist" @input="createDeleteDroit(droit)" />
        </div>
      </template>
    </section>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
  },
  async asyncData({ $api }) {
    const profilsCreateur = await $api.droitCreationProfils.allProfilWithDroit();
    return {
      profilsCreateur,
    };
  },
  methods: {
    async createDeleteDroit(droit) {
      try {
        if (droit.exist) {
          await this.$api.droitCreationProfils.post(droit);
        } else {
          await this.$api.droitCreationProfils.delete(droit.profilCreateur.id, droit.profilCree.id);
        }
      } catch ({ response: { status }, message }) {
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
        // si ca plante on annule la coche !
        // eslint-disable-next-line no-param-reassign
        droit.exist = !droit.exist;
      }
    },
  },
};
</script>

<style scoped lang="scss">
.grid-droit-creation-profil {
  display: grid;
  grid-template-columns: 150px repeat(var(--grid-size), 1fr);

  div {
    border-bottom: 1px solid #eee;
    display: flex;
    padding: 1em;
    justify-content: center;

    span {
      font-size: 0.7rem;
      color: #888;
      text-align: center;
    }
  }
}
</style>
